# I3DExWireFrameSet Struct Reference
[External Interfaces]

Inheritance diagram for I3DExWireFrameSet:

List of all members.

## Public Member Functions
virtual MCCOMErr MCCOMAPI | TrackWireFrame (I3DShWireFrameSet *wireFrame, int16 proj, I3DShTreeElement *tree, I3DEditorHostPanePart *panePart, const TWFHitInfo &handle, const TRACKINFO &startinfo, const TRACKINFO &previnfo, const TRACKINFO &nextinfo, I3DShCamera *camera)=0
virtual MCCOMErr MCCOMAPI | DataToWireFrame (I3DShWireFrameSet *wireFrame, int16 proj, I3DShTreeElement *tree, I3DShCamera *camera)=0
virtual MCCOMErr MCCOMAPI | WireFrameToData (I3DShWireFrameSet *wireFrame, int16 proj, I3DShTreeElement *tree, I3DShCamera *camera)=0
virtual MCCOMErr MCCOMAPI | GetWireFrameBBox (TBBox3D *outBBox, int16 proj, I3DShTreeElement *tree)=0
virtual MCCOMErr MCCOMAPI | GetGlobalTransform (I3DShTreeElement *tree, TTransform3D &outTransform)=0
virtual void MCCOMAPI | ShowWFTools (boolean show)=0
virtual boolean MCCOMAPI | HandlesTool (int16 inTool)=0
virtual boolean MCCOMAPI | TestHit (I3DShTreeElement *tree, const Ray3D &localRay, const real64 tmin, TWFHitInfo &outInfo)=0
virtual boolean MCCOMAPI | IsViewDependent () const =0
virtual void MCCOMAPI | GetActionName (TMCString &outName)=0
virtual real32 MCCOMAPI | GetScalingFactor () const =0
virtual void MCCOMAPI | SetScalingFactor (real32 inValue)=0

## Detailed Description

Defines a set of wireframe that can be use to control certain properties of an object, deformer,...

## Member Function Documentation

virtual MCCOMErr MCCOMAPI I3DExWireFrameSet::DataToWireFrame | ( | I3DShWireFrameSet * | wireFrame,
|  | int16 | proj,
|  | I3DShTreeElement * | tree,
|  | I3DShCamera * | camera |
| ) |  |  | `[pure virtual]`

This is where you should create the wireframe

Parameters:

  | wireFrame | The internal wireframe
  | proj | This is the 'hit' projection (-1: invalid, 0: XY, 1: YZ, 2: XZ, 3: 3D) WARNING : other projections than 3 are deprecated
  | tree | The tree that has the wireframe
  | camera | The camera of the current view

Implemented in TBasicWireframeSet.

virtual void MCCOMAPI I3DExWireFrameSet::GetActionName | ( | TMCString & | outName | ) | `[pure virtual]`

Returns the name of the action associated with TrackWireFrame (displayed by undo) If that function is not implemented, the default name is "Move"

Parameters:

  | outName | The name of the action.

Implemented in TBasicWireframeSet.

virtual MCCOMErr MCCOMAPI I3DExWireFrameSet::GetGlobalTransform | ( | I3DShTreeElement * | tree,
|  | TTransform3D & | outTransform |
| ) |  |  | `[pure virtual]`

Gets the transform to apply to the wireframe data to convert it into global space

Note:
  Only implement this method if your wf data is not stored in the tree's local coordinates

Parameters:

  | tree | the tree that has the wireframe
  | outTransform | the wfdata to world transform

Returns:
  MC_S_OK if outTransform is set, or MC_E_NOTIMPL to use the default

Implemented in TBasicWireframeSet.

virtual real32 MCCOMAPI I3DExWireFrameSet::GetScalingFactor | ( |  | ) | const`[pure virtual]`

Returns the name scaling factor that should be applied to the object

Implemented in TBasicWireframeSet.

virtual MCCOMErr MCCOMAPI I3DExWireFrameSet::GetWireFrameBBox | ( | TBBox3D * | outBBox,
|  | int16 | proj,
|  | I3DShTreeElement * | tree |
| ) |  |  | `[pure virtual]`

Gets the wire frame bounding box

Parameters:

  | outBBox | The resulting bounding box
  | proj | This is the 'hit' projection (-1: invalid, 0: XY, 1: YZ, 2: XZ, 3: 3D)
  | tree | The tree that has the wireframe

Implemented in TBasicWireframeSet.

virtual boolean MCCOMAPI I3DExWireFrameSet::HandlesTool | ( | int16 | inTool | ) | `[pure virtual]`

Return true if the given tool is to be used on handles.

Parameters:

  | inTool | The given tool ID.

Implemented in TBasicWireframeSet.

virtual boolean MCCOMAPI I3DExWireFrameSet::IsViewDependent | ( |  | ) | const`[pure virtual]`

Must return True if the wireframe depends on the view, to False otherwise

Implemented in TBasicWireframeSet.

virtual void MCCOMAPI I3DExWireFrameSet::SetScalingFactor | ( | real32 | inValue | ) | `[pure virtual]`

Sets the scaling factor to be applied to the object

Parameters:

  | inValue | the scaling factor

Implemented in TBasicWireframeSet.

virtual void MCCOMAPI I3DExWireFrameSet::ShowWFTools | ( | boolean | show | ) | `[pure virtual]`

Give the component a change to show or hide the Wire Frame tools

Parameters:

  | show | True if should show the tools, False if should hide.

Implemented in TBasicWireframeSet.

virtual boolean MCCOMAPI I3DExWireFrameSet::TestHit | ( | I3DShTreeElement * | tree,
|  | const Ray3D & | localRay,
|  | const real64 | tmin,
|  | TWFHitInfo & | outInfo |
| ) |  |  | `[pure virtual]`

For wireframes that consider themselves surfaces (eg scale manipulators) computes the intersection of the given ray and the wire's surface

Parameters:

  | tree | The tree.
  | localRay | The ray with which the intersection is calculated.
  | outInfo | The info about the intersection if there is one.

Returns:
  true is there is an intersection and fills outInfo

Implemented in TBasicWireframeSet.

virtual MCCOMErr MCCOMAPI I3DExWireFrameSet::TrackWireFrame | ( | I3DShWireFrameSet * | wireFrame,
|  | int16 | proj,
|  | I3DShTreeElement * | tree,
|  | I3DEditorHostPanePart * | panePart,
|  | const TWFHitInfo & | handle,
|  | const TRACKINFO & | startinfo,
|  | const TRACKINFO & | previnfo,
|  | const TRACKINFO & | nextinfo,
|  | I3DShCamera * | camera |
| ) |  |  | `[pure virtual]`

This function is called whenever the wire frame is tracked in 3dview.

Parameters:

  | wireFrame | The internal wireframe
  | proj | This is the 'hit' projection (-1: invalid, 0: XY, 1: YZ, 2: XZ, 3: 3D)
  | tree | The tree that has the wireframe
  | panePart | The pane part where the wireframe is tracked
  | handle | The element which is tracked
  | startinfo | The track info when the track started
  | previnfo | The last track info before this call
  | nextinfo | The new track info
  | camera | The camera of the current view

Implemented in TBasicWireframeSet.

virtual MCCOMErr MCCOMAPI I3DExWireFrameSet::WireFrameToData | ( | I3DShWireFrameSet * | wireFrame,
|  | int16 | proj,
|  | I3DShTreeElement * | tree,
|  | I3DShCamera * | camera |
| ) |  |  | `[pure virtual]`

Implemented in TBasicWireframeSet.

The documentation for this struct was generated from the following file:

- I3DWireFrameSet.h